#include "m_pd.h"


// HACK !!!
struct _glist
{
    t_object gl_obj;            /* header in case we're a glist */
    t_gobj *gl_list;            /* the actual data */
    struct _gstub *gl_stub;     /* safe pointer handler */
    int gl_valid;               /* incremented when pointers might be stale */
    struct _glist *gl_owner;    /* parent glist, supercanvas, or 0 if none */
};
// END HACK !!!


typedef struct pwd
{
    t_object x_ob;
    t_canvas * x_canvas;
    t_outlet* x_outlet;
} t_pwd;


static void pwd_bang(t_pwd *x)
{
    outlet_symbol(x->x_outlet,canvas_getdir(x->x_canvas));
}

t_class *pwd_class;

static void *pwd_new(void)
{
    t_pwd *x = (t_pwd *)pd_new(pwd_class);
    x->x_canvas =  canvas_getcurrent();
    while (x->x_canvas->gl_owner) x->x_canvas = x->x_canvas->gl_owner;
    x->x_outlet = outlet_new(&x->x_ob, &s_);
    return (void *)x;
}

void pwd_setup(void)
{
    pwd_class = class_new(gensym("pwd"), (t_newmethod)pwd_new, 0,
    	sizeof(t_pwd), 0, 0);
    class_addbang(pwd_class, pwd_bang);
}

